/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
/*
  Progress Monitor for some theli processes
  application form added to theliform.ui
  created with QT Designer 3.3.7
  Author: Carsten Moos
  Date: 08.11.2010
  tested for theli 2.2.3 of 07.11.2010
  consists of: pmonitor.h, pmonitor.ui, pmonitor.ui.h (this), pmonitorfuntions.h
  anchors to theliform.ui.h / Menu / Progress Monitor 
  is non modal
  */
#include <qapplication.h>
#include <qlineedit.h>
#include <qmessagebox.h>
#include <qpushbutton.h>
#include <pmonitor.h>
#include <qlistbox.h>
#include <qstring.h>
#include <stdio.h>
#include <qsettings.h>
#include "functions.h"
#include <unistd.h>
#include <qtimer.h>
#include <qmessagebox.h>
#include <qlabel.h>
#include "globalvariables.h"
#include "pmonitorfunctions.h"

/*

*/

int GBL_Start_Queue=1;             // can be set by theliform.ui Start / Abort
int AGAIN=1;                       // 0 stopps Timer

QString subdir1,pattern1,pattern2="",pattern3="";
int iBASICfilecounter=0;
QTimer *timer;
QString EXTstatus;
int Total=0,Intervall=1000;    // time ellapsed, timer intervall
void pmonitor::p_start()
{
    int group=-1;
    QString SEARCH_PATH_PATTERN;
    QString execstr,result,Info;
    pattern1=""; 
    pattern2="";
    pattern3="";

    Info = progress_listBox->currentItem();
    progress_info->setText(Info + ";" + sciencepath +";" +mainpath);
    
    group=progress_listBox->currentItem(); 
    if (group==0)                       // Automatik: Itemnr=0
    {
	if (process_group=="pre") progress_listBox->setCurrentItem(1);
	if (process_group=="cal") progress_listBox->setCurrentItem(2);
	if (process_group=="w") progress_listBox->setCurrentItem(3);
	if (process_group=="ap") progress_listBox->setCurrentItem(4);
	if (process_group=="cc") 
	    {
	  // Seperate different processes in this group
	  //ps -j x|grep skysub|grep -v grep|wc -l
	   execstr = " ps -j x|grep skysub|grep -v grep|wc -l";
               my_fscanf(execstr, result);
	   if (atoi(result) >0)   
	       progress_listBox->setCurrentItem(5);   // subskying
	   else
	       progress_listBox->setCurrentItem(6);   // resampling
		
	       // if (theliForm->cc_commandTextEdit.countains ("skysub")) progress_listBox->setCurrentItem(5);
	       // if (theliForm->cc_commandTextEdit .contains("resample_coadd")) progress_listBox->setCurrentItem(6);

	    }
    }
    group=progress_listBox->currentItem(); 
    //Automatik, Korrektur des Inkrements fuer group
    group--;		// decrementing Listorder in respect of automatic 
    if (group ==-1) {
    QMessageBox::warning( this,"Automatic", "Processing group not recognized. Theli is not working.");
    }
    else
    {
    
    EXTstatus=get_ext(); 
    if (EXTstatus=="" ) EXTstatus ="OFC";   // backup, ext_imgch not always correct???
    AGAIN=1;                                // enable TIMER
         // Count all Calibrated files
    SEARCH_PATH_PATTERN=sciencepath + "/*" +EXTstatus +".fits";
	 
    switch (group)
    {
       case 0:
         iBASICfilecounter=count2(sciencepath);  // hier werden alle sciencefiles gezaehlt.
         subdir1="";
         pattern1="*_?.fits"; // Count subFiles CPU=1
         pattern2="*_??.fits"; // Count subFiles CPU=11
         break;	
       case 1:  //calibrating all Sensors
       {
         iBASICfilecounter=count3(sciencepath);  // hier werden alle preprocessed  files gezaehlt.
         subdir1="";
         pattern1="*_?"   +EXTstatus +".fits"; // Count subFiles CPU=1
         pattern2="*_??" +EXTstatus +".fits";// Count subFiles CPU=11
	 if (get_BAYER(sciencepath)) {
		iBASICfilecounter*=3;
           	//pattern3="*_[RGB]_*" +EXTstatus +".fits";// Count Bayerfiles CPU=*
	 } 
        break;
       }	
       case 2:  //weighting
       {
	iBASICfilecounter=count1(SEARCH_PATH_PATTERN);
        subdir1="/../WEIGHTS";
        pattern1="*"+EXTstatus+".weight.fits"; // Count subFiles
        break;
       }
       case 3:  //createcatalog
       {
	iBASICfilecounter=count1(SEARCH_PATH_PATTERN);
        subdir1="/cat";
        pattern1="*"+EXTstatus+".cat1"; // Count subFiles
        break;
       }

       case 4:  //subsky
       {
	iBASICfilecounter=count1(SEARCH_PATH_PATTERN);
        subdir1="";
        pattern1="*"+EXTstatus+"*sub.fits"; // Count subFiles, model = OFC_skysub.fits
//      if (theliForm->cc_commandTextEdit.countains ("ALL"))  restart=1
        break;
       }
       case 5:  //resamp
       {
	iBASICfilecounter=count1(SEARCH_PATH_PATTERN);
	subdir1="/coadd_"+ident;
	pattern1="*"+EXTstatus+"*.resamp.fits"; // Count subFiles
 
         // Count filtered OFC
         iBASICfilecounter=count1(sciencepath +subdir1 + "/*"+EXTstatus+"*.head");
	 break;
       }
       default:
         AGAIN=0;    // Stopps Timer, paranoid
    }

progress_startpushButton->setEnabled(FALSE);     // disable start-button
timer->start( Intervall, FALSE );                // 1 seconds  timer

    }  // end of else
//QMessageBox::warning( this,"Debuginfo", "EXTstatus: " +EXTstatus);
}


void pmonitor::init()
{
QString str,execstr,VERSION=" 0.26";
    this->setCaption(this->caption()+ VERSION); 
    
    progress_info->setText("init");
    progress_listBox-> removeItem(0);

    progress_listBox-> insertItem(QString("Automatic          "));   
    progress_listBox-> insertItem(QString("Preprocessing      "));
    progress_listBox-> insertItem(QString("Calibrating        "));
    progress_listBox-> insertItem(QString("Weighting          "));
    progress_listBox-> insertItem(QString("Creating Catalogs  "));
    progress_listBox-> insertItem(QString("Subtracting sky    "));
    progress_listBox-> insertItem(QString("Resampling         "));
    progress_listBox->setCurrentItem(0);   // Automatic as default
    progress_info->setText("init + list inserted");
    
     
    get_paths();

    timer = new QTimer( this );
    connect( timer, SIGNAL(timeout()), this, SLOT(timer_done()) );
    
     // create Timestamp
    TouchStamp(mainpath);
}
void pmonitor::destroy()
{
// disconnect( timer, SIGNAL(timeout()), this, SLOT(timer_done()) )  ;
 delete  timer;
}

void pmonitor::p_reset()
{
progress_info->setText("Reset");
progress_status->setText("");
progressBar->setProgress(0); // -1 waere logisch, geht aber nicht
progress_startpushButton->setEnabled(1);
AGAIN=0;
timer->stop(); //  timer off
Total=0;
get_paths();  // reread science and mainpath
progress_listBox->setCurrentItem(0);   // Automatik
}



void pmonitor::timer_done()
{
QString execstr,result;
int status=0;
int iCURfilecounter=0;
Total+= (int)(Intervall/1000.0);

//process 1
if (pattern1 !="")
  {
    execstr = "{ find  ";
    execstr.append(sciencepath +subdir1 +"/");
    execstr.append(" -maxdepth 1 -newer " +mainpath +"/pmon-stamp -name ");
    execstr.append("\"" + pattern1 +"\" ");
    if (pattern2 !="") execstr.append( "; find  "+sciencepath +subdir1 +"/" +" -maxdepth 1 -newer " +mainpath +"/pmon-stamp -name \"" + pattern2 +"\"  2>/dev/null " );
    if (pattern3 !="") execstr.append( "; find  "+sciencepath +subdir1 +"/" +" -maxdepth 1 -newer " +mainpath +"/pmon-stamp -name \"" + pattern3 +"\"  2>/dev/null " );
    execstr.append( "; }");	
    execstr.append("|wc -l");

    my_fscanf(execstr, result);
    iCURfilecounter=atoi(result);
    progress_info->setText(QString::number(iCURfilecounter)+";" + QString::number(iBASICfilecounter) + ";" +pattern1+"||"+pattern2);
    status=(int)(iCURfilecounter*100.0/iBASICfilecounter);
    progressBar->setProgress(status);
    
  }
if (iCURfilecounter >0){ 
progress_status->setText("Counter: " + QString::number(iCURfilecounter)+" of " + QString::number(iBASICfilecounter) +", Time: " +QString::number(Total) +" s of " + QString::number((int)(Total *1.0 / iCURfilecounter*iBASICfilecounter)) +" s ");
}
else
progress_status->setText("waiting ...");

if (!(GBL_Start_Queue && AGAIN && status <100))
    {
    timer->stop();	
    progress_startpushButton->setEnabled(TRUE);
    progress_status->setText("Done");
 // create Timestamp
      TouchStamp(mainpath);
      progress_info->setText(execstr);
      Total=0;
      progress_listBox->setCurrentItem(0);   // automatic
      // if (restart) pmonitor::p_start()
    }

}
