#ifndef SECTION_SF_H
#define SECTION_SF_H

void theliForm::resetfields_sf_pushbutton()
{
  sf_useunsmoothedCheckBox->setChecked(false);
  sf_useofftargetCheckBox->setChecked(false);
  sf_adjustgainsCheckBox->setChecked(false);
  sf_fringescaleCheckBox->setChecked(true);
  sf_chopnodinvertCheckBox->setChecked(false);
  sf_chopnodpatternComboBox->setCurrentItem(0);
  sf_sexbacksizeLineEdit->setText("256");
  sf_smoothfringeLineEdit->clear();
  sf_numbergroupsLineEdit->setText("3");
  sf_messagesTextEdit->clear();
  update_logfile();
  update_sf_commandlist();
}


void theliForm::clearscripts_sf_pushbutton()
{
  sf_illumfringeCheckBox->setChecked(false);
  sf_procillumCheckBox->setChecked(false);
  sf_procfringeCheckBox->setChecked(false);
  sf_procsubsfCheckBox->setChecked(false);
  sf_chopnodCheckBox->setChecked(false);
  sf_collapseCheckBox->setChecked(false);
  sf_mergesequenceCheckBox->setChecked(false);
  sf_messagesTextEdit->clear();
  CB_createillumfringe = 0;
  CB_superflat = 0;
  CB_defringe = 0;
  CB_subsf = 0;
  CB_chopnod = 0;
  CB_mergesequence = 0;
  CB_collapse = 0;
  paint_checkboxes();
  science_sf = 0;
  science_df = 0;
  science_subsf = 0;
  science_coll = 0;
  science_chopnod = 0;
  offtarget_sf = 0;
  offtarget_df = 0;
  offtarget_subsf = 0;
  offtarget_chopnod = 0;
  offtarget_coll = 0;
  update_logfile();
  update_sf_commandlist();
  statusCPSSuperflattingAction->setOn(false);
  statusCPSDefringingAction->setOn(false);
  statusCPSSubSUPERFLATAction->setOn(false);
  statusCPSChopnodAction->setOn(false);
  statusCPSCollapseAction->setOn(false);
}


void theliForm::toggle_sfbuttons_optical()
{
  if (sf_procillumCheckBox->isChecked() || sf_procfringeCheckBox->isChecked()) {
    sf_procsubsfCheckBox->setDisabled(true);
  }
  else
    sf_procsubsfCheckBox->setEnabled(true);
}


void theliForm::toggle_sfbuttons_ir()
{
  if (sf_procsubsfCheckBox->isChecked()) {
    sf_procillumCheckBox->setDisabled(true);
    sf_procfringeCheckBox->setDisabled(true);
    sf_useunsmoothedCheckBox->hide();
    sf_adjustgainsCheckBox->hide();
  }
  else {
    sf_procillumCheckBox->setEnabled(true);
    sf_procfringeCheckBox->setEnabled(true);
    sf_useunsmoothedCheckBox->show();
    sf_adjustgainsCheckBox->show();
  }
}


void theliForm::update_sf_commandlist()
{
  QString mainpath, smoothingscale;
  QString sciencespread, offtargetspread, standardspread;
  QString bias, flat, science, offtarget, standard;
  QString numbergroups, numbergroupsstring, pattern, invert;
  QString superflatillum, superflatfringe, superflatunsmoothed;
  QDir e;
  int CB_array[8], stop = 0;
  int checkscience, checkofftarget, useofftarget, processofftarget;
  int checkstandard;
  int i, breakcondition, numbergroupsint, noscience, noofftarget;
  int num_sf_un, num_sf_il, num_sf_fr, num_sf_un_off;
  int num_sf_il_off, num_sf_fr_off, flag = 0, flag_ini = 0;
  
  sf_commandTextEdit->setReadOnly(false);

  repaint_parameter_fields_sf();
  
  science_sf = 0;
  science_df = 0;
  science_subsf = 0;
  science_chopnod = 0;
  science_coll = 0;
  science_debloom = 0;
  science_directphot = 0;
  offtarget_sf = 0;
  offtarget_subsf = 0;
  offtarget_df = 0;
  offtarget_chopnod = 0;
  offtarget_coll = 0;
  offtarget_debloom = 0;
  offtarget_directphot = 0;
  
  QRegExp ri( "^[-]{0,1}[0-9]+" );
  QValidator* validator_int = new QRegExpValidator( ri, this );
  sf_sexbacksizeLineEdit->setValidator( validator_int );
  sf_smoothfringeLineEdit->setValidator( validator_int );
  sf_numbergroupsLineEdit->setValidator( validator_int );
  
  // clear the command list window
  sf_commandTextEdit->setText(empty);

  // check the status of the check boxes. 
  // write the status into an array for easier handling
  for (i=0; i<=6; i++) CB_array[i] = 0;

  if (sf_illumfringeCheckBox->isChecked()) CB_array[0] = 1; 
  if (sf_procillumCheckBox->isChecked()  && sf_procillumCheckBox->isEnabled())   CB_array[1] = 1; 
  if (sf_procfringeCheckBox->isChecked() && sf_procfringeCheckBox->isEnabled())  CB_array[2] = 1; 
  if (sf_procsubsfCheckBox->isChecked()  && sf_procsubsfCheckBox->isEnabled())   CB_array[3] = 1; 
  if (sf_chopnodCheckBox->isChecked())       CB_array[4] = 1; 
  if (sf_mergesequenceCheckBox->isChecked()) CB_array[5] = 1; 
  if (sf_collapseCheckBox->isChecked())      CB_array[6] = 1; 
  
  // check that the main path is absolute
  QDir absmainpath = QDir(in_maindirLineEdit->text());
  if (absmainpath.isRelative() && sum(CB_array,8) > 0) {
    warn(sf_commandTextEdit,"STOP: The main path given under \"Initialise\" must be absolute!");
    return;
  }
  
  // the superflatting method and the gain method
  if (sf_useofftargetCheckBox->isChecked()) useofftarget = 1; 
  else useofftarget = 0; 
  
  // the main data directory
  mainpath = in_maindirLineEdit->text();
  
  // the subdirectories
  bias      = in_biasdirLineEdit->text();
  flat      = in_flatdirLineEdit->text();
  science   = in_sciencedirLineEdit->text();
  offtarget = in_offtargetdirLineEdit->text();
  standard  = in_standarddirLineEdit->text();
  
  // check if the data directories actually exist
  checkscience   = checkdir(mainpath, science);
  checkofftarget = checkdir(mainpath, offtarget);
  checkstandard  = checkdir(mainpath, standard);

  if (checkscience == 0 && (
  	CB_array[0] == 1 || CB_array[1] == 1 || CB_array[2] == 1 || 
  	CB_array[3] == 1 || CB_array[4] == 1 || CB_array[5] == 1 ||
  	CB_array[6] == 1)) {
    warn(sf_commandTextEdit,"STOP: SCIENCE directory not found.");
    return;
  }

  // hide the "use offtarget" checkbox if no valid
  // OFFTARGET dir was entered
  if (checkofftarget == 0) sf_useofftargetCheckBox->hide();
  if (checkofftarget == 1) sf_useofftargetCheckBox->show();

  // only process the offtarget data if the user explicitly requested it
  processofftarget = 1;
  if (!in_processofftargetCheckBox->isChecked() || checkofftarget == 0) 
    processofftarget = 0;

  // check if the superflat data exists already
  QDir sciencepath = QDir(mainpath+"/"+science);
  QDir offtargetpath = QDir(mainpath+"/"+offtarget);
  num_sf_un = sciencepath.entryList(science+"_*.fits").count();
  num_sf_il = sciencepath.entryList(science+"_*_illum.fits").count();
  num_sf_fr = sciencepath.entryList(science+"_*_fringe.fits").count();
  num_sf_un_off = offtargetpath.entryList(offtarget+"_*.fits").count();
  num_sf_il_off = offtargetpath.entryList(offtarget+"_*_illum.fits").count();
  num_sf_fr_off = offtargetpath.entryList(offtarget+"_*_fringe.fits").count();

  // create the commands and update the command list window
  
  // create illumfringe
  if (CB_array[0] == 1) {
    smoothingscale = sf_sexbacksizeLineEdit->text();
    if (!smoothingscale.isEmpty() && num_sf_un > 0) {
      create_scriptcall_1(sf_commandTextEdit, 1, "create_illumfringe_para.sh", mainpath, science);
    }
    
    if (num_sf_un < 1) {
      warn(sf_commandTextEdit,"STOP: Smooth SUPERFLAT: Could not find superflat!");
      stop = 1;
    }
    if (smoothingscale.isEmpty()) {
      warn(sf_commandTextEdit,"STOP: Smooth SUPERFLAT: Please enter a smoothing scale!");
      stop = 1;
    }
    if (checkofftarget == 1 && !smoothingscale.isEmpty() && num_sf_un_off < 1) {
      warn(sf_commandTextEdit,"STOP: Smooth SUPERFLAT: Could not find offtarget superflat!");
      stop = 1;
    }
    if (checkofftarget == 1 && !smoothingscale.isEmpty() && num_sf_un_off > 0 && stop == 0) {
      create_scriptcall_1(sf_commandTextEdit, 1, "create_illumfringe_para.sh", mainpath, offtarget);
    }
  }
  
  // process science+offtarget illum
  if (CB_array[1] == 1) {
    if (checkofftarget == 0 && useofftarget == 1 && 
	!sf_useofftargetCheckBox->isHidden() &&
	sf_useofftargetCheckBox->isChecked() && num_sf_un_off < 1) {
      warn(sf_commandTextEdit,"STOP: Superflat data: No OFFTARGET superflat found!");
      stop = 1;
    }
    if (checkofftarget == 1 && useofftarget == 1 && stop == 0) {
      create_scriptcall_2(sf_commandTextEdit, 1, "use_offtarget_superflat_para.sh",
			  mainpath, science, offtarget);
    }
    if (checkofftarget == 0 && useofftarget == 1 && !sf_useofftargetCheckBox->isHidden()) {
      warn(sf_commandTextEdit,"STOP: Superflat data: No OFFTARGET directory specified."); 
      warn(sf_commandTextEdit,"    If you don't have offtarget data, uncheck the \"Use OFFTARGET SUPERFLAT\" switch.");
      stop = 1;
    }
    
    if (num_sf_il<1 && !sf_illumfringeCheckBox->isChecked() &&
	!sf_useunsmoothedCheckBox->isChecked()) {
      warn(sf_commandTextEdit,"STOP: Superflat data: Could not find smoothed superflat."); 
      stop = 1;
      if (num_sf_un>0 && !sf_useunsmoothedCheckBox->isChecked()) {
	warn(sf_commandTextEdit,"    A superflat seems to be present. Run the \"Smooth SUPERFLAT\" step first,");
	warn(sf_commandTextEdit,"    or use the \"Use unsmoothed SUPERFLAT\" option.");
      }
      if (num_sf_un<1 && (!cal_procscienceCheckBox->isChecked() || !cal_superflatCheckBox->isChecked())) {
	warn(sf_commandTextEdit,"    Apparently none is going to be created. You can create it in the");
	warn(sf_commandTextEdit,"    \"Calibration\" section or from the \"Miscellaneous->Combine folder of images\" menu."); 
      }
    }
    else {
      science_sf = 1;
      science_subsf = 0;
      create_scriptcall_1(sf_commandTextEdit, 1, "process_science_illum_para.sh", mainpath, science);
      
      if (flag == 0) check_filepresence(sf_commandTextEdit, science, "OFC", flag, flag_ini);
      
      if (checkstandard == 1) {
	if (checkofftarget == 1 && useofftarget == 1) {
	  create_scriptcall_2(sf_commandTextEdit, 1, "use_offtarget_superflat_para.sh",
			      mainpath, standard, offtarget);
	} else {
	  create_scriptcall_2(sf_commandTextEdit, 1, "use_offtarget_superflat_para.sh",
			      mainpath, standard, science);
	}
	
	if (flag == 0) check_filepresence(sf_commandTextEdit, standard, "OFC", flag, flag_ini);
	
	create_scriptcall_1(sf_commandTextEdit, 1, "process_science_illum_para.sh", mainpath, standard);
      }
    }
    
    if (processofftarget == 1) {
      if (num_sf_il_off<1 && !sf_illumfringeCheckBox->isChecked() &&
	  !sf_useunsmoothedCheckBox->isChecked()) {
	warn(sf_commandTextEdit,"STOP: Superflat data: Could not find smoothed offtarget superflat."); 
	stop = 1;
	if (num_sf_un_off>0 && !sf_useunsmoothedCheckBox->isChecked()) 
	  warn(sf_commandTextEdit,"    An offtarget superflat seems to be present. Run the \"Smooth SUPERFLAT\" step first.");
	if (num_sf_un_off<1 && (!cal_procscienceCheckBox->isChecked() || !cal_superflatCheckBox->isChecked())) {
	  warn(sf_commandTextEdit,"    Apparently none is going to be created. You can create it in the");
	  warn(sf_commandTextEdit,"    \"Calibration\" section or from the \"Miscellaneous->Combine folder of images\" menu."); 
	}
      }
      else {
	offtarget_sf = 1;
	offtarget_subsf = 0;
	
	if (flag == 0) check_filepresence(sf_commandTextEdit, offtarget, "OFC", flag, flag_ini);
	
	create_scriptcall_1(sf_commandTextEdit, 1, "process_science_illum_para.sh", mainpath, offtarget);
      }
    } else offtarget_sf = 0;
  }
  else {
    science_sf = 0;
    offtarget_sf = 0;
  }
  
  // process science+offtarget fringe
  if (CB_array[2] == 1) {
    get_fitsext_fordefringe(ext_img,ext_imgch);
    get_lastchar(ext_imgch);
    if (CB_array[1] == 1 && lastchar.compare("C") == 0) 
      ext_imgch.append("S");
    if (invoked_fromexecall == 1) 
      get_fitsext_fromcheckboxes("forcollapse");
    
    if (num_sf_fr<1 && !sf_illumfringeCheckBox->isChecked()) {
      warn(sf_commandTextEdit,"STOP: Defringe data: Could not find a fringing model!"); 
      if (num_sf_un>0) 
	warn(sf_commandTextEdit,"    A superflat seems to be present. Run the \"Smooth SUPERFLAT\" step first.");
      else {
	warn(sf_commandTextEdit,"    Could not find a superflat either. You must create it first in the"); 
	warn(sf_commandTextEdit,"    \"Calibration\" section or from the \"Miscellaneous->Combine folder of images\" menu."); 
      }
    }
    else {
      science_df = 1;
      science_subsf = 0;
      if (flag == 0) check_filepresence(sf_commandTextEdit, science, ext_imgch, flag, flag_ini);
      create_scriptcall_2(sf_commandTextEdit, 1, "process_science_fringe_para.sh", mainpath, science, ext_imgch);
      
      if (checkstandard == 1) {
  	if (flag == 0) check_filepresence(sf_commandTextEdit, standard, ext_imgch, flag, flag_ini);
	create_scriptcall_2(sf_commandTextEdit, 1, "process_science_fringe_para.sh", mainpath, standard, ext_imgch);
      }
    }
    
    if (processofftarget == 1) {
      if (num_sf_fr_off<1 && !sf_illumfringeCheckBox->isChecked()) {
	warn(sf_commandTextEdit,"STOP: Defringe data: Could not find a offtarget fringing model!"); 
	if (num_sf_un_off>0) 
	  warn(sf_commandTextEdit,"    An offtarget superflat seems to be present. Run the \"Smooth SUPERFLAT\" step first.");
	else {
	  warn(sf_commandTextEdit,"    Could not find a offtarget superflat either. You must create it first in the"); 
	  warn(sf_commandTextEdit,"    \"Calibration\" section or from the \"Miscellaneous->Combine folder of images\" menu."); 
	}
      }
      else {
	offtarget_df = 1;
	offtarget_subsf = 0;
	if (flag == 0) check_filepresence(sf_commandTextEdit, offtarget, ext_imgch, flag, flag_ini);
	create_scriptcall_2(sf_commandTextEdit, 1, "process_science_fringe_para.sh", 
			    mainpath, offtarget, ext_imgch);
      }
    } else offtarget_df = 0;
  }
  else {
    science_df = 0;
    offtarget_df = 0;
  }


  // SUBTRACT THE UNSMOOTHED SUPERFLAT
  // loop over the spread sequence

  sciencespread = science;
  offtargetspread = offtarget;
  breakcondition = 0;
  numbergroupsint = 1;
  noscience = 0;
  noofftarget = 0;
  i = 1;

  // correct num_sf_un if data is spread out over the spread_sequence
  QString ng, science_tmp, offtarget_tmp;
  
  if (cal_spreadsequenceCheckBox->isChecked() || CB_spreadsequence == 1) {
    numbergroupsstring = cal_numbergroupsLineEdit->text();
    numbergroupsint = numbergroupsstring.toInt();
    if (numbergroupsint > 1) {
      for (i=1; i<=numbergroupsint; i++) {
	science_tmp = science+"_S"+ng.setNum(i);
	offtarget_tmp = offtarget+"_S"+ng.setNum(i);
	sciencepath = QDir(mainpath+"/"+science_tmp);
	offtargetpath = QDir(mainpath+"/"+offtarget_tmp);
	num_sf_un += sciencepath.entryList(science_tmp+"_*.fits").count();
	num_sf_un_off += offtargetpath.entryList(offtarget_tmp+"_*.fits").count();
      }
    }
  }
  
  for (i=1; i<=numbergroupsint; i++) {
    
    if ( (cal_spreadsequenceCheckBox->isChecked() || CB_spreadsequence == 1)) {
      sciencespread = science;
      sciencespread.append("_S");
      sciencespread.append(numbergroupsstring.setNum(i));
      offtargetspread = offtarget;
      offtargetspread.append("_S");
      offtargetspread.append(numbergroupsstring.setNum(i));
    }
    else {
      sciencespread = science;
      offtargetspread = offtarget;
    }
    
    // subtract the unsmoothed superflat
    if (CB_array[3] == 1) {
      if (noscience == 0) {
	if (checkofftarget == 1 && useofftarget == 1) {
	  create_scriptcall_2(sf_commandTextEdit, 1, "use_offtarget_superflat_para.sh",
			      mainpath, sciencespread, offtargetspread);
	}
	if (num_sf_un<1 && useofftarget == 0 && 
	    (!cal_procscienceCheckBox->isChecked() || !cal_superflatCheckBox->isChecked())) {
	  warn(sf_commandTextEdit,"STOP: Subtract SUPERFLAT: Could not find the superflat."); 
	  warn(sf_commandTextEdit,"    You must create it first in the \"Calibration\" section or"); 
	  warn(sf_commandTextEdit,"    from the \"Miscellaneous->Combine folder of images\" menu."); 
	}
	else {
	  science_subsf = 1;
	  science_sf = 0;
	  science_df = 0;
	  if (flag == 0) check_filepresence(sf_commandTextEdit, sciencespread, "OFC", flag, flag_ini);
	  create_scriptcall_1(sf_commandTextEdit, 1, 
			      "process_science_subsuperflat_para.sh",
			      mainpath, sciencespread);
	  
	  if (checkstandard == 1) {
	    if (checkofftarget == 1 && useofftarget == 1) {
	      if (flag == 0) check_filepresence(sf_commandTextEdit, standard, "OFC", flag, flag_ini);
	      create_scriptcall_2(sf_commandTextEdit, 1, "use_offtarget_superflat_para.sh",
				  mainpath, standard, offtarget);
	    } else {
	      if (flag == 0) check_filepresence(sf_commandTextEdit, standard, "OFC", flag, flag_ini);
	      create_scriptcall_2(sf_commandTextEdit, 1, "use_offtarget_superflat_para.sh",
				  mainpath, standard, science);
	    }
	    if (flag == 0) check_filepresence(sf_commandTextEdit, standardspread, "OFC", flag, flag_ini);
	    create_scriptcall_1(sf_commandTextEdit, 1, "process_science_subsuperflat_para.sh", 
				mainpath, standardspread);
	  }
	}
      } else science_subsf = 0;
      
      if (checkofftarget == 0 && useofftarget == 1 && !sf_useofftargetCheckBox->isHidden()) {
	warn(sf_commandTextEdit,"STOP: Subtract SUPERFLAT: No OFFTARGET directory specified.");
	warn(sf_commandTextEdit,"    If you don't have offtarget data, uncheck the \"Use OFFTARGET SUPERFLAT\" switch.");
	stop = 1;
      } 
      if (checkscience == 0) {
	warn(sf_commandTextEdit,"STOP: Subtract SUPERFLAT: SCIENCE directory not found!"); 
	stop = 1;
      }
      
      if (noofftarget == 0 && processofftarget == 1) {
	if (num_sf_un_off<1 && (!cal_procscienceCheckBox->isChecked() || !cal_superflatCheckBox->isChecked())) {
	  warn(sf_commandTextEdit,"STOP: Subtract SUPERFLAT: Could not find the offtarget superflat."); 
	  warn(sf_commandTextEdit,"    You must create it first in the \"Calibration\" section or"); 
	  warn(sf_commandTextEdit,"    from the \"Miscellaneous->Combine folder of images\" menu.");
	  stop = 1;
	}
	else {
	  offtarget_subsf = 1;
	  offtarget_sf = 0;
	  offtarget_df = 0;
	  if (flag == 0) check_filepresence(sf_commandTextEdit, offtargetspread, "OFC", flag, flag_ini);
	  create_scriptcall_1(sf_commandTextEdit, 1, "process_science_subsuperflat_para.sh",
			      mainpath, offtargetspread);
	}
      } else offtarget_subsf = 0;
    }
    else {
      science_subsf = 0;
      offtarget_subsf = 0;
    }
    // break after one step if the breakcondition is true
    if (breakcondition == 1) break;
  }
  

  // Do the chopnod sky subtraction
  // loop over the spread sequence

  sciencespread = science;
  offtargetspread = offtarget;
  breakcondition = 0;
  numbergroupsint = 1;
  noscience = 0;
  noofftarget = 0;
  i = 1;

  if ( (cal_spreadsequenceCheckBox->isChecked() || CB_spreadsequence == 1)) {
    numbergroupsstring = cal_numbergroupsLineEdit->text();
    numbergroupsint = numbergroupsstring.toInt();
  }

  for (i=1; i<=numbergroupsint; i++) {
    
    if ( (cal_spreadsequenceCheckBox->isChecked() || CB_spreadsequence == 1)) {
      sciencespread = science;
      sciencespread.append("_S");
      sciencespread.append(numbergroupsstring.setNum(i));
      offtargetspread = offtarget;
      offtargetspread.append("_S");
      offtargetspread.append(numbergroupsstring.setNum(i));
    }
    else {
      sciencespread = science;
      offtargetspread = offtarget;
    }
    
    // do the pairwise sky subtraction
    if (CB_array[4] == 1) {
      get_fitsext_forchopnod(ext_img,ext_imgch);
      get_lastchar(ext_imgch);
      if (sf_chopnodinvertCheckBox->isChecked()) invert="1";
      else invert = "0";
      if (noscience == 0) {
	pattern = "P" + sf_chopnodpatternComboBox->currentText();
	if (CB_array[3] == 0) {
	  if (CB_array[1] == 1 && CB_array[2] == 0 && lastchar.compare("C") == 0) 
	    ext_imgch.append("S");
	  if (CB_array[1] == 1 && CB_array[2] == 1 && lastchar.compare("C") == 0) 
	    ext_imgch.append("SF");
	  if (CB_array[2] == 1 && lastchar.compare("S") == 0) 
	    ext_imgch.append("F");
	  if (invoked_fromexecall == 1) 
	    get_fitsext_fromcheckboxes("forcollapse");
	}
	else {
	  if (lastchar.compare("C") == 0) ext_imgch.append("U");
	}
	if (flag == 0) check_filepresence(sf_commandTextEdit, sciencespread, ext_imgch, flag, flag_ini);
	create_scriptcall_4(sf_commandTextEdit, 1, "process_science_chopnod_para.sh",
			    mainpath, sciencespread, ext_imgch, pattern, invert);
	science_chopnod = 1;
      } else science_chopnod = 0;
      if (checkscience == 0) 
	warn(sf_commandTextEdit,"STOP: Chop/Nod sky subtraction: SCIENCE directory not found!"); 
      
      if (noofftarget == 0 && processofftarget == 1) {
	if (CB_array[3] == 0) {
	  if (CB_array[1] == 1 && CB_array[2] == 0 && lastchar.compare("C") == 0) 
	    ext_imgch.append("S");
	  if (CB_array[1] == 1 && CB_array[2] == 1 && lastchar.compare("C") == 0) 
	    ext_imgch.append("SF");
	  if (CB_array[2] == 1 && lastchar.compare("S") == 0) 
	    ext_imgch.append("F");
	  if (invoked_fromexecall == 1) 
	    get_fitsext_fromcheckboxes("forcollapse");
	}
	else {
	  if (lastchar.compare("C") == 0) ext_imgch.append("U");
	}
	if (flag == 0) check_filepresence(sf_commandTextEdit, offtargetspread, ext_imgch, flag, flag_ini);
	create_scriptcall_4(sf_commandTextEdit, 1, "process_science_chopnod_para.sh",
			    mainpath, offtargetspread, ext_imgch, pattern, invert);
	offtarget_chopnod = 1;
      } else offtarget_chopnod = 0;
    }
    else {
      science_chopnod = 0;
      offtarget_chopnod = 0;
    }
    // break after one step if the breakcondition is true
    if (breakcondition == 1) break;
  }
  
  // merge sequence again
  if (CB_array[5] == 1) {
    numbergroups = sf_numbergroupsLineEdit->text();
    get_fitsext_forcollmerge(ext_img,ext_imgch);
    get_lastchar(ext_imgch);
    if (numbergroups.isEmpty())
      warn(sf_commandTextEdit,"STOP: Merge sequence: Please specify the number of groups.");
    else {
      if (CB_array[3] == 0) {
	if (CB_array[1] == 1 && CB_array[2] == 0 && lastchar.compare("C") == 0) 
	  ext_imgch.append("S");
	if (CB_array[1] == 1 && CB_array[2] == 1 && lastchar.compare("C") == 0) 
	  ext_imgch.append("SF");
	if (CB_array[2] == 1 && lastchar.compare("S") == 0) 
	  ext_imgch.append("F");
	if (invoked_fromexecall == 1) 
	  get_fitsext_fromcheckboxes("forcollapse");
      }
      else
	if (lastchar.compare("C") == 0) ext_imgch.append("U");
      if (CB_array[4] == 1) ext_imgch.append("H");
      if (CB_array[4] == 0 && invoked_fromexecall == 1)
	get_fitsext_fromcheckboxes("forcollapse");
      
      if (flag == 0) {
	for (i=1; i<=numbergroupsint; i++) {
	  sciencespread = science;
	  sciencespread.append("_S");
	  sciencespread.append(numbergroupsstring.setNum(i));
	}
	check_filepresence(sf_commandTextEdit, sciencespread, ext_imgch, flag, flag_ini);
      }
      create_scriptcall_3(sf_commandTextEdit, 0, "merge_sequence.sh", 
			  mainpath, science, ext_imgch, numbergroups);
      
      if (processofftarget == 1) {
	if (flag == 0) {
	  for (i=1; i<=numbergroupsint; i++) {
	    offtargetspread = offtarget;
	    offtargetspread.append("_S");
	    offtargetspread.append(numbergroupsstring.setNum(i));
	  }
	  check_filepresence(sf_commandTextEdit, offtarget, ext_imgch, flag, flag_ini);
	}
	create_scriptcall_3(sf_commandTextEdit, 0, "merge_sequence.sh", 
			    mainpath, offtarget, ext_imgch, numbergroups);
      }
    }
  }

  // collapse correction 
  if (CB_array[6] == 1 && stop == 0) {
    get_fitsext_forcollmerge(ext_img,ext_imgch);
    get_lastchar(ext_imgch);
    if (CB_array[3] == 0) {
      if (CB_array[1] == 1 && CB_array[2] == 0 && lastchar.compare("C") == 0) 
	ext_imgch.append("S");
      if (CB_array[1] == 1 && CB_array[2] == 1 && lastchar.compare("C") == 0) 
	ext_imgch.append("SF");
      if (CB_array[2] == 1 && lastchar.compare("S") == 0) 
	ext_imgch.append("F");		
      if (invoked_fromexecall == 1) 
	get_fitsext_fromcheckboxes("forcollapse");
    }
    else {
      if (lastchar.compare("C") == 0) ext_imgch.append("U");
      if (invoked_fromexecall == 1) 
	get_fitsext_fromcheckboxes("forcollapse");
    }
    if (CB_array[4] == 1) ext_imgch.append("H");	
    if (CB_array[4] == 0 && invoked_fromexecall == 1) 
      get_fitsext_fromcheckboxes("forcollapse");

    if (flag == 0) check_filepresence(sf_commandTextEdit, science, ext_imgch, flag, flag_ini);
    create_scriptcall_2(sf_commandTextEdit, 1, "process_collapsecorr_para.sh", 
			mainpath, science, ext_imgch);
    science_coll = 1;
    
    if (processofftarget == 1) {
      if (flag == 0) check_filepresence(sf_commandTextEdit, offtarget, ext_imgch, flag, flag_ini);
      create_scriptcall_2(sf_commandTextEdit, 1, "process_collapsecorr_para.sh", 
			  mainpath, offtarget, ext_imgch);
      offtarget_coll = 1;
    } else offtarget_coll = 0;
  }
  else {
    science_coll = 0;
    offtarget_coll = 0;
  }
}


void theliForm::repaint_parameter_fields_sf()
{
  repaint_parameter_fields_helper(sf_illumfringeCheckBox, sf_sexbacksizeLineEdit);
  repaint_parameter_fields_helper(sf_mergesequenceCheckBox, sf_numbergroupsLineEdit);
}


void theliForm::link_useofftargetbuttons()
{
  QSettings settings (QSettings::Ini);
  QString reductionlog = in_reductionlogLineEdit->text();
  if (reductionlog.isEmpty()) {
    reductionlog = "noname";
  }
  
  settings.beginGroup("/theli_"+reductionlog+"_");
  settings.beginGroup("/WEIGHTING");
  if (sf_useofftargetCheckBox->isChecked()) 
    settings.writeEntry("/useofftarget", true);
  else settings.writeEntry("/useofftarget", false);
  settings.endGroup();
  settings.endGroup();
}


void theliForm::exec_sf()
{
  QString fullpath, scripts, presentinst;
  
  int result;
  is_imextension_empty(result);
  if (result == 1) return;
  
  // update the params.ini
  modify_paramsini();
  modify_paramset2();
  
  fullpath = userscriptdir;
  fullpath.append("/");
  fullpath.append("theli_sf_comm.sh");
  
  scripts = sf_commandTextEdit->text();
  if (scripts.contains("STOP:") != 0) return;
  presentinst = tf_instrumentLineEdit->text();
  
  // write the superscript and execute it
  process_group = "sf";
  
  if (checkdir2(userscriptdir) == 1 && !presentinst.isEmpty() && 
      !scripts.isEmpty()) {	
    write_superscriptbody(fullpath, scripts);
  }
}


void theliForm::kill_sf()
{
  QString execstr;
  
  if (started_proc_sf == 1) {
    if (proc_sf->isRunning()) {
      process_id = proc_sf->processIdentifier();
      pid = pid.setNum(process_id);
      execstr = scriptdir;
      execstr.append("/parakill.sh ");
      execstr.append(pid);
      execstr.append(" > /dev/null 2>&1");
      my_system(execstr);
      sf_messagesTextEdit->append("All processes killed.");	
    }
    started_proc_sf = 0;
  }
}

#endif
