#ifndef _ECLIPSE_ALL_INCLUDES_
#define _ECLIPSE_ALL_INCLUDES_

/* Unix includes come first, in this order */
#include "config.h"

#include "calendar.h"
#include "charmatrix.h"
#include "chronos.h"
#include "cmdline.h"
#include "comm.h"
#include "dictionary.h"
#include "e_config.h"
#include "e_version.h"
#include "file_handling.h"
#include "filelock.h"
#include "filename.h"
#include "filesys.h"
#include "getopt.h"
#include "gnuplot_i.h"
#include "iniparser.h"
#include "manpage.h"
#include "memstr.h"
#include "parse_tok.h"
#include "pid_i.h"
#include "show.h"
#include "strlib.h"
#include "t_iso8601.h"
#include "t_stamp.h"
#include "userid.h"

/* Local types and globals */
#include "local_types.h"
#include "pi.h"

/* Math routines */
#include "chebyshev.h"
#include "doubles.h"
#include "dstats.h"
#include "fft_base.h"
#include "fit_curve.h"
#include "function_1d.h"
#include "ipow.h"
#include "legendre.h"
#include "matrix.h"
#include "median.h"
#include "optimization.h"
#include "poly2d.h"
#include "polygon.h"
#include "random.h"

/* Image processing routines */
#include "corner.h"
#include "cube2image.h"
#include "cube_arith.h"
#include "cube_defs.h"
#include "cube_filters.h"
#include "cube_handling.h"
#include "cube_load.h"
#include "cube_save.h"
#include "dead_pixels.h"
#include "detect.h"
#include "detector.h"
#include "extraction.h"
#include "fourier.h"
#include "framelist.h"
#include "generate.h"
#include "histogram.h"
#include "history.h"
#include "image_arith.h"
#include "image_filters.h"
#include "image_handling.h"
#include "image_intops.h"
#include "image_io.h"
#include "image_rtd.h"
#include "image_stats.h"
#include "intimage.h"
#include "irstd.h"
#include "matchpoint.h"
#include "photometry.h"
#include "pixel_handling.h"
#include "pixelmaps.h"
#include "resampling.h"
#include "shift.h"
#include "static_sz.h"
#include "xcorrelation.h"

#endif
