#!/bin/bash

# HISTORY INFORMATION:
#
# 16.05.2010:
# sanity check for the relation between available
# chips and parallel processes. Missing it led
# to too many launched processes if the camera has 
# fewer chips than parallel channels 

. ${INSTRUMENT:?}.ini

# sanity check:
if [ ${NPARA} -gt ${NCHIPS} ]; then
  NPARA=${NCHIPS}
fi

# do some initialisations
i=1
while [ ${i} -le ${NPARA} ]
do
  PARA[$i]=""
  i=$(( $i + 1 ))
done

# now divide the chips to the processors:
k=1
while [ ${k} -le ${NCHIPS} ]
do
  ACTUPROC=1
  while [ ${ACTUPROC} -le ${NPARA} ]
  do
    PARA[${ACTUPROC}]="${PARA[${ACTUPROC}]} ${k}"
    k=$(( $k + 1 ))
    ACTUPROC=$(( $ACTUPROC + 1 ))
  done
done

# finally start all the processes
SCRIPT=$1
shift
ARGS=$*

k=1
while [ ${k} -le ${NPARA} ]
do
  ( ./${SCRIPT} ${ARGS} "${PARA[${k}]}" ) &
  k=$(( $k + 1 ))
done

# wait until all subprocesses have finished
wait

exit 0;
